AppTitle "Blasto 3D", "Are you sure you wish to terminate Blasto 3D?"
frameRate = 40
versionNumber$ = "1.0.0"

; CONFIG FILE
Global Details
Global Debug
Global Sound
Global SoundVol#
filConfig = OpenFile("blasto3d.cfg")
If filConfig = 0 Then
	RuntimeError "Please run the Blasto3D configuration utility."
Else
	scrWidth = ReadLine(filConfig)
	scrHeight = ReadLine(filConfig)
	scrDepth = ReadLine(filConfig)
	scrMode = ReadLine(filConfig)
	Graphics3D scrWidth, scrHeight, scrDepth, scrMode
	AntiAlias ReadLine(filConfig)
	Dither ReadLine(filConfig)
	WBuffer ReadLine(filConfig)
	Details = ReadLine(filConfig)
	Debug = ReadLine(filConfig)
	SoundVol# = Float(ReadLine(filConfig)) / 100.0
	Sound = SoundVol# > 0
	Temp = ReadLine(filConfig)
	BTU = ReadLine(filConfig)
	BTR = ReadLine(filConfig)
	BTD = ReadLine(filConfig)
	BTL = ReadLine(filConfig)
	BTF = ReadLine(filConfig)
	WTU = ReadLine(filConfig)
	WTR = ReadLine(filConfig)
	WTD = ReadLine(filConfig)
	WTL = ReadLine(filConfig)
	WTF = ReadLine(filConfig)
End If

Delay 1000

SetBuffer BackBuffer()
frmRate = CreateTimer(frameRate)
HidePointer
SeedRnd MilliSecs()

AmbientLight 255, 255, 255

Global SkipIntro
texLogo = LoadTexture("images\logo.jpg")
objLogo = CreateCube()
EntityTexture objLogo, texLogo

camDefault = CreateCamera()
CameraProjMode camDefault, 1

MoveEntity camDefault, 0, 0, -8.5

ScaleEntity objLogo, 8, 6, 0.1

ResetSkip()

alpha# = 0

While alpha < 1 And (Not CheckSkip())

	WaitTimer frmRate

	EntityAlpha objLogo, alpha
	
	UpdateWorld
	RenderWorld
	
	Flip
	
	alpha = alpha + 0.02

Wend

timr = MilliSecs()
While timr > MilliSecs() - 2000 And (Not CheckSkip())
Wend

While alpha > 0 And (Not CheckSkip())

	WaitTimer frmRate

	EntityAlpha objLogo, alpha
	
	UpdateWorld
	RenderWorld
	
	Flip

	alpha = alpha - 0.03

Wend

FlushKeys
FreeTexture texLogo
FreeEntity objLogo
FreeEntity camDefault
ResetSkip()

.Intro
; ORIGINAL TI LOADING SCREEN + RECORDED PLAY OF ORIGINAL BLASTO

vidIntro = OpenMovie("videos\intro.avi")

If Sound Then
	sndIntro = LoadSound("videos\intro.wav")
	SoundVolume sndIntro, SoundVol#
	PlaySound sndIntro
End If
While MoviePlaying(vidIntro) And (Not CheckSkip())
	DrawMovie vidIntro, 0, 0, scrWidth, scrHeight
	Flip
Wend

CloseMovie vidIntro
If Sound Then FreeSound sndIntro

.Menu
; GLOBALS
Include "init.bb"
Include "functions.bb"

sr# = Float(scrWidth) / Float(1024)

imgLoading = LoadImage("images\loading.bmp")
MaskImage imgLoading, 255, 0, 255
ScaleImage imgLoading, sr#, sr#
CenterImage(imgLoading, 0, 0, scrWidth, scrHeight)
Flip

; LOAD SOUNDS
If Sound Then

	sndMenu = LoadSound("sounds\menu.mp3")
	LoopSound sndMenu
	SoundVolume sndMenu, SoundVol# / 2

	sndMusic = LoadSound("sounds\music.mp3")
	LoopSound sndMusic
	SoundVolume sndMusic, SoundVol# / 2

	sndEnhanced = LoadSound("sounds\enhanced.mp3")
	LoopSound sndEnhanced
	SoundVolume sndEnhanced, SoundVol# * 0.6

	sndExplosion = LoadSound("sounds\explosion.wav")
	SoundVolume sndExplosion, SoundVol#
	
	sndClick = LoadSound("sounds\click.wav")
	SoundVolume sndClick, SoundVol#
	
	sndBTank = Load3DSound("sounds\tank.wav")
	LoopSound sndBTank
	SoundVolume sndBTank, SoundVol# / 3

	sndWTank = Load3DSound("sounds\tank.wav")
	LoopSound sndWTank
	SoundVolume sndWTank, SoundVol# / 3

	sndBullet = Load3DSound("sounds\bullet.wav")
	SoundVolume sndBullet, SoundVol#
	sndShell = Load3DSound("sounds\shell.wav")
	SoundVolume sndShell, SoundVol#
	sndMissile = Load3DSound("sounds\missile.wav")
	SoundVolume sndMissile, SoundVol#
	
	For I = 1 To 5
		sndExplosions(I) = Load3DSound("sounds\explosion" + i + ".wav")
		SoundVolume sndExplosions(I), SoundVol#
	Next

End If

; MAIN MENU

Global Quit = False
Global Menu = False
Global Redo = False
imgMenu1 = LoadImage("images\menu-1.jpg")
imgMenu2 = LoadImage("images\menu-2.jpg")
imgMenu3 = LoadImage("images\menu-3.jpg")
MaskImage imgMenu1, 255, 0, 255
ScaleImage imgMenu1, sr#, sr#
MaskImage imgMenu2, 255, 0, 255
ScaleImage imgMenu2, sr#, sr#
MaskImage imgMenu3, 255, 0, 255
ScaleImage imgMenu3, sr#, sr#

imgCursor = LoadImage("images\select.bmp")
MaskImage imgCursor, 255, 0, 255
ScaleImage imgCursor, sr#, sr#
MidHandle imgCursor

fntDefault = LoadFont("Arial", 20, True)
SetFont fntDefault
Color 0, 0, 0

Players = 1
GameSpeed = RAPID
Motion = NORMAL
MineDensity = NORMAL
TankTrails = SEVERAL
Mode = 1

LastTT = TankTrails
LastMD = MineDensity

If Sound Then chnMenu = PlaySound(sndMenu)

While Not Quit

	WaitTimer frmRate
	; CHOOSE THE GAME OPTIONS

	DrawImage imgMenu1, 0, 0
	If Players = 2 Then
		DrawImage imgMenu2, 54 * sr#, 329 * sr#
		If TankTrails = OBSTACLES Then
			DrawImage imgMenu3, 515 * sr#, 144 * sr#
		End If
	End If	
	Text 760 * sr#, 114 * sr#, VersionNumber$

	If Players = 1 Then
		DrawImage imgCursor, 98 * sr#, 205 * sr#
	Else
		DrawImage imgCursor, 98 * sr#, 280 * sr#
		If Motion = NORMAL Then
			DrawImage imgCursor, 98 * sr#, 390 * sr#
		Else
			DrawImage imgCursor, 98 * sr#, 465 * sr#
		End If			
	End If
	If Mode = 1 Then
		DrawImage imgCursor, 588 * sr#, 535 * sr#
	Else
		DrawImage imgCursor, 588 * sr#, 600 * sr#
	End If
	Select GameSpeed
		Case SLUGGISH
			DrawImage imgCursor, 313 * sr#, 205 * sr#
		Case RAPID
			DrawImage imgCursor, 313 * sr#, 280 * sr#
		Case FULLTILT
			DrawImage imgCursor, 313 * sr#, 355 * sr#
	End Select
	If TankTrails = OBSTACLES Then
		DrawImage imgCursor, 313 * sr#, 540 * sr#
	Else
		If Players = 2 Then
			DrawImage imgCursor, 313 * sr#, 465 * sr#
		End If
		If TankTrails = SEVERAL Then
			DrawImage imgCursor, 568 * sr#, 205 * sr#
		Else
			DrawImage imgCursor, 568 * sr#, 280 * sr#
		End If
	End If
	If TankTrails <> OBSTACLES Then
		Select MineDensity
			Case HIGH
				DrawImage imgCursor, 788 * sr#, 205 * sr#
			Case NORMAL
				DrawImage imgCursor, 788 * sr#, 280 * sr#
			Case LOW
				DrawImage imgCursor, 788 * sr#, 355 * sr#
		End Select
	End If
		
	DrawImage imgCursor, MouseX()+1, MouseY()
	DrawImage imgCursor, MouseX(), MouseY()+1
	DrawImage imgCursor, MouseX()+1, MouseY()+1
	DrawImage imgCursor, MouseX(), MouseY()
	Flip
	
	; CLICKS
	mouse = GetMouse()
	If mouse = 1 Then
		; GAME MODE
		If MouseArea(570 * sr#, 510 * sr#, 180 * sr#, 50 * sr#) Then
			If Sound Then PlaySound sndClick
			Mode = 1
		ElseIf MouseArea(570 * sr#, 575 * sr#, 180 * sr#, 50 * sr#) Then
			If Sound Then PlaySound sndClick
			Mode = 2
		; PLAYERS
		ElseIf MouseArea(80 * sr#, 180 * sr#, 180 * sr#, 50 * sr#) Then
			If Sound Then PlaySound sndClick
			Players = 1
			TankTrails = LastTT
			MineDensity = LastMD
		ElseIf MouseArea(80 * sr#, 255 * sr#, 180 * sr#, 50 * sr#) Then
			If Sound Then PlaySound sndClick
			Players = 2
		; GAME SPEED
		ElseIf MouseArea(295 * sr#, 180 * sr#, 180 * sr#, 50 * sr#) Then
			If Sound Then PlaySound sndClick
			GameSpeed = SLUGGISH
		ElseIf MouseArea(295 * sr#, 255 * sr#, 180 * sr#, 50 * sr#) Then
			If Sound Then PlaySound sndClick
			GameSpeed = RAPID
		ElseIf MouseArea(295 * sr#, 330 * sr#, 180 * sr#, 50 * sr#) Then
			If Sound Then PlaySound sndClick
			GameSpeed = FULLTILT
		; TANK MOTION
		ElseIf MouseArea(80 * sr#, 365 * sr#, 180 * sr#, 50 * sr#) Then
			If Players = 2 Then
				If Sound Then PlaySound sndClick
				Motion = NORMAL
			End If
		ElseIf MouseArea(80 * sr#, 440 * sr#, 180 * sr#, 50 * sr#) Then
			If Players = 2 Then
				If Sound Then PlaySound sndClick
				Motion = INVISIBLE
			End If
		; BATTLEGROUND
		ElseIf MouseArea(295 * sr#, 440 * sr#, 180 * sr#, 50 * sr#) Then
			If Players = 2 Then
				If Sound Then PlaySound sndClick
				TankTrails = LastTT
				MineDensity = LastMD
			End If	
		ElseIf MouseArea(295 * sr#, 515 * sr#, 180 * sr#, 50 * sr#) Then
			If Players = 2 Then
				If Sound Then PlaySound sndClick
				LastTT = TankTrails
				LastMD = MineDensity
				TankTrails = OBSTACLES
			End If
		; TANK TRAILS
		ElseIf MouseArea(550 * sr#, 180 * sr#, 180 * sr#, 50 * sr#) Then
			If TankTrails <> OBSTACLES Then
				If Sound Then PlaySound sndClick
				TankTrails = SEVERAL
				LastTT = TankTrails
			End If		
		ElseIf MouseArea(550 * sr#, 255 * sr#, 180 * sr#, 50 * sr#) Then
			If TankTrails <> OBSTACLES Then
				If Sound Then PlaySound sndClick
				TankTrails = NONE
				LastTT = TankTrails
			End If
		; MINE DENSITY
		ElseIf MouseArea(770 * sr#, 180 * sr#, 180 * sr#, 50 * sr#) Then
			If TankTrails <> OBSTACLES Then					
				If Sound Then PlaySound sndClick
				MineDensity = HIGH
				LastMD = MineDensity
			End If		
		ElseIf MouseArea(770 * sr#, 255 * sr#, 180 * sr#, 50 * sr#) Then
			If TankTrails <> OBSTACLES Then
				If Sound Then PlaySound sndClick
				MineDensity = NORMAL
				LastMD = MineDensity
			End If		
		ElseIf MouseArea(770 * sr#, 330 * sr#, 180 * sr#, 50 * sr#) Then
			If TankTrails <> OBSTACLES Then
				If Sound Then PlaySound sndClick
				MineDensity = LOW
				LastMD = MineDensity
			End If		

		; PLAY
		ElseIf MouseArea(800 * sr#, 515 * sr#, 180 * sr#, 50 * sr#) Then
			If Sound Then PlaySound sndClick
			Invis = Motion = INVISIBLE
		
			Menu = False
			
			If Sound Then StopChannel chnMenu
			While (Not Menu)
				; PLAY UNTIL REDO OR MENU
				CenterImage(imgLoading, 0, 0, scrWidth, scrHeight)
				Flip
				If Sound And Mode = 1 Then chnMusic = PlaySound(sndMusic)
				If Sound And Mode = 2 Then chnMusic = PlaySound(sndEnhanced)
				Include "play.bb"
				If Sound Then StopChannel chnMusic
			Wend
			If Sound Then chnMenu = PlaySound(sndMenu)
			
			While KeyDown(1)
			Wend
			
		; QUIT
		ElseIf MouseArea(800 * sr#, 580 * sr#, 180 * sr#, 50 * sr#) Then
			If Sound Then PlaySound sndClick
			Quit = True
		End If
	
	End If
	
	If KeyDown(1) Then Quit = True

Wend

Delay 500

End