Function CheckSkip()
	If GetKey() <> 0 Or GetMouse() <> 0 Then
		SkipIntro = True
	End If
	Return SkipIntro
End Function

Function ResetSkip()
	SkipIntro = False
	FlushKeys
End Function

Function MouseArea(x, y, width, height)
	If MouseX() >= x And MouseX() <= x + width
		If MouseY() >= y And MouseY() <= y + height
			Return True
		Else
			Return False
		End If
	Else
		Return False
	End If

End Function

Function ShadowText(x, y, txt$, center_x, center_y)
	r = ColorRed()
	g = ColorGreen()
	b = ColorBlue()
	Color 0, 0, 0
	Text(x+1, y+1, txt$, center_x, center_y)
	Color r, g, b
	Text(x, y, txt$, center_x, center_y)

End Function

Function OutlineText(x, y, txt$, center_x, center_y)
	r = ColorRed()
	g = ColorGreen()
	b = ColorBlue()
	Color 0, 0, 0
	Text(x+1, y, txt$, center_x, center_y)
	Text(x-1, y, txt$, center_x, center_y)
	Text(x, y+1, txt$, center_x, center_y)
	Text(x, y-1, txt$, center_x, center_y)
	Color r, g, b
	Text(x, y, txt$, center_x, center_y)

End Function

Function Wrap360#(angle#)
	While angle < 0
		angle = angle + 360
	Wend
	While angle > 359
		angle = angle - 360
	Wend
	Return angle
	
End Function

Function PointDistance#(x1#, y1#, z1#, x2#, y2#, z2#)
	width# = x1# - x2#
	height# = y1# - y2#
	depth# = z1# - z2#
	Return Sqr#(witdh * width + depth * depth + height * height)

End Function

Function Distance#(x1#, y1#, x2#, y2#)
	width# = x1# - x2#
	height# = y1# - y2#
	dist# = Sqr#(width * width + height * height) 
	Return dist

End Function

Function X3D#(X)
	Return Float(Float(X) * 128 / Float(LX) - 64)
End Function

Function Z3D#(Y)
	Return Float(Float(Y) * 85 / Float(LY) - 64)
End Function

Function GridX(X#)
	Return Int((X# + 64) * Float(LX) / 128.0)
End Function

Function GridY(Z#)
	Return Int((Z# + 64) * Float(LY) / 85.0)
End Function

Function DrawScore(Scr, imgScore, X, screenRatio#)
	Score$ = Scr
	While Len(Score$) < 5
		Score$ = "0" + Score$
	Wend
	For Count = 0 To 4
		DrawImage imgScore, X * ScreenRatio# + (Count * 35 + 5) * ScreenRatio#, 80 * ScreenRatio#, Mid(Score$, Count+1, 1)
	Next
End Function

Function HandleMovement(objTank, objTankShadow, ID, TU, TD, TR, TL, TF)

	LastX#(ID) = EntityX(objTank)
	LastZ#(ID) = EntityZ(objTank)

	Key = False
	If KeyDown(TU)
		Direction = 1
		Angle = 180
		Key = True
	ElseIf KeyDown(TD)
		Direction = 2
		Angle = 0
		Key = True
	ElseIf KeyDown(TR)
		Direction = 3
		Angle = 90
		Key = True
	ElseIf KeyDown(TL)
		Direction = 4
		Angle = 270
		Key = True
	End If

	If Not(Spin(ID) Or Disable(ID)) Then
		If Key Then
			If Dir(ID) <> Direction Then
				Speed#(ID) = 0
				RotateEntity objTank, 0, Angle, 0
				PositionEntity objTank, X3D(GridX(EntityX(objTank))), EntityY(objTank), Z3D(GridY(EntityZ(objTank)))
				Dir(ID) = Direction 
			End If
			Speed#(ID) = Speed#(ID) + TANKACC#
			If Speed#(ID) > TANKSpeed# Then
				Speed#(ID) = TANKSpeed#
			End If
		Else
			If KeyDown(TF) And (Not Shot(ID))
				Shot(ID) = True
				If Mode = 2 Then
					Select Weapon(ID)
						Case SHELL
							NextShot(ID) = MilliSecs() + NEXTSHELL * Reload#(ID)
							If Sound And Mode = 2 Then EmitSound(sndShell, objTank)
						Case BULLET
							NextShot(ID) = MilliSecs() + NEXTBULLET * Reload#(ID)
							If Sound And Mode = 2 Then EmitSound(sndBullet, objTank)

						Case MISSILE
							NextShot(ID) = MilliSecs() + NEXTMISSILE * Reload#(ID)
							If Sound And Mode = 2 Then EmitSound(sndMissile, objTank)
					End Select
				End If
				Bullets.Bullet = New Bullet
				Bullets\shooter = ID
				Select Weapon(ID)
					Case SHELL
						Bullets\St = STSHELL
						Bullets\Rad = 1
						sc# = 1
					Case BULLET
						Bullets\St = STBULLET
						Bullets\Rad = 1
						sc# = 0.6
					Case MISSILE
						Bullets\St = STMISSILE
						Bullets\Rad = 2
						sc# = 1.4
				End Select
				Bullets\mdl = CreateSphere(6)
				PositionEntity Bullets\mdl, EntityX(objTank), EntityY(objTank), EntityZ(objTank)
				ScaleEntity Bullets\mdl, sc#, sc#, sc#
				RotateEntity Bullets\mdl, 0, EntityYaw(objTank), 0
				MoveEntity Bullets\mdl, 0, 0, -0
				EntityTexture Bullets\mdl, texBullet
				Bullets\mdlShadow = CreateSphere(6, Bullets\mdl)
				MoveEntity Bullets\mdlShadow, 0, -2.5, 0
				ScaleEntity Bullets\mdlShadow, 1, 0.1, 1
				EntityColor Bullets\mdlShadow, 0, 0, 0
				EntityAlpha Bullets\mdlShadow, 0.4
			End If
		End If
	ElseIf Spin(ID)
		Speed#(ID) = 0
		Spinning(ID) = Spinning(ID) + 1
		TurnEntity objTank, 0, GS, 0
		If Spinning(ID) = 1080 / GS Then
			Spinning(ID) = 0
			Spin(ID) = False
			Disable(ID) = True
		End If
	End If
	If Repo(1) And (Not(Spin(1) Or Spin(2))) Then
		PositionEntity objBlackTank, X3D(TX(1)), 0, Z3D(TY(1))
		RotateEntity objBlackTank, 0, 90, 0
		Repo(1) = False
		Disable(2) = False
		Dir(1) = 0
	End If
	If Repo(2) And (Not(Spin(1) Or Spin(2))) Then
		PositionEntity objWhiteTank, X3D(TX(2)), 0, Z3D(TY(2))
		RotateEntity objWhiteTank, 0, 270, 0
		Repo(2) = False
		Disable(1) = False
		Dir(2) = 0
	End If
	If (Not Repo(1)) And (Not Spin(1)) And (Not Repo(2)) And (Not Spin(2)) Then
		Disable(1) = False
		Disable(2) = False
	End If
	
	If Powers(ID, 1) > 0 Then
		Speed#(ID) = Speed#(ID) * 1.1
	End If
	If Powers(ID, 2) > 0 Then
		Speed#(ID) = Speed#(ID) * 0.9
	End If
	MoveEntity objTank, 0, 0, -1 * Speed#(ID)
	If Invis Then
		Alpha# = 1.0 - (Speed#(ID) / 1)
		If Alpha# < 0 Then
			Alpha# = 0
		End If
		EntityAlpha objTank, Alpha#
		EntityAlpha objTankShadow, Alpha# * 0.6
	End If
	
	If Speed#(ID) <> 0 Then
		Speed#(ID) = Speed#(ID) * SPEEDDECREASE#
		If Speed#(ID) > 0 And Speed#(ID) < TANKACC# * BACKWARD# Then
			Speed#(ID) = 0
		ElseIf Speed#(ID) < 0 And Speed#(ID) > TANKACC# * BACKWARD# Then
			Speed#(ID) = 0
		End If
	End If
	ptcNew = 22000 + Speed#(ID) * 4000
	If ptcNew <> ptcTank(ID) Then
		ptcTank(ID) = ptcNew
		ChannelPitch chnTank(ID), ptcNew
	End If

	GX = GridX(EntityX(objTank, True))
	GY = GridY(EntityZ(objTank, True))
	For PowerUps.PowerUp = Each PowerUp
		If GX = PowerUps\X And GY = PowerUps\Y Then
			Select ID
				Case 1
					Tank$ = "Black tank"
				Case 2
					Tank$ = "White tank"
			End Select
			P = 0
			Select PowerUps\typ
				Case 1
					P = 1
					NewMessage$ = Tank$ + " acquired a speed boost."
				Case 2
					P = 2
					NewMessage$ = Tank$ + "'s speed decreased."
				Case 3
					Reload#(ID) = 1
					Weapon(ID) = BULLET
					NewMessage$ = Tank$ + " got a new weapon: machine gun."
				Case 4
					Reload#(ID) = 1
					Weapon(ID) = SHELL
					NewMessage$ = Tank$ + " got a new weapon: tank cannon."
				Case 5
					Reload#(ID) = 1
					Weapon(ID) = MISSILE
					NewMessage$ = Tank$ + " got a new weapon: missile launcher."
				Case 6
					P = 3
					NewMessage$ = Tank$ + " is now invulnerable."
				Case 7
					P = 4
					NewMessage$ = Tank$ + " has now bulldozing abilities."
				Case 8
					TimeLeft = TimeLeft + 5000
					NewMessage$ = "5 seconds bonus!"
				Case 9
					TimeLeft = TimeLeft - 5000
					NewMessage$ = "5 seconds penalty!"
				Case 10
					Scores(ID) = Scores(ID) + 500
					NewMessage$ = Tank$ + " gets 500 points bonus!"
				Case 11
					NewMessage$ = "Air strike!"
					For i = 1 To 7
						r = Rand(1, 100)
						If r <= 30 Then
						    r = 1
						ElseIf r <= 90 Then
						    r = 2
						Else
							r = 3
						End If
						Explosion(Rand(1, LX), Rand(1, LY), r, ID, 10)
					Next
				Case 12
					NewMessage$ = "New mines arose!"
					For i = 1 To 10
						Repeat
							X = Rand(1, LX)
							Y = Rand(1, LY)
						Until Lvl(X, Y) = " "
						GreenMines = GreenMines + 1
						GM.GreenMine = New GreenMine
						If Details = HIGH Then
							GM\mdl = LoadMesh("models\green.b3d")
							ScaleEntity GM\mdl, 0.05, 0.05, 0.05
						Else
							GM\mdl = LoadSprite("models\green.bmp", 4)
							SpriteViewMode GM\mdl, 1
							ScaleSprite GM\mdl, 3, 3
						End If
						GM\X = X
						GM\Y = Y
						GM\HP = 2
						Lvl(X, Y) = "X"
						MoveEntity GM\mdl, X3D(X), -2, Z3D(Y)
					Next
				Case 13
					NewMessage$ = Tank$ + "'s weapon now reload faster!"
					Reload#(ID) = Reload#(ID) * 0.9
				Case 14
					NewMessage$ = Tank$ + "'s weapon now reload slower!"
					Reload#(ID) = Reload#(ID) * 1.1
				Case 15
					NewMessage$ = "A-Bomb!"
					Explosion(Rand(1, LX), Rand(1, LY), 5, ID, 10)
			End Select
			NewR = (ID - 1) * 255
			NewG = (ID - 1) * 255
			NewB = (ID - 1) * 255
		    AddMessages()
			If P > 0 Then
				If Powers(ID, P) = 0 Then
					Powers(ID, P) = MilliSecs() + 11000
				Else
					Powers(ID, P) = Powers(ID, P) + 6000
				End If
			End If
			FreeEntity PowerUps\mdlShadow
			FreeEntity PowerUps\mdl
			Delete PowerUps.PowerUp
		End If
	Next

	GX = GridX(EntityX(objTank, True))
	GY = GridY(EntityZ(objTank, True))
	If GX <= LX And GX >= 1 And GY <= LY And GY >= 1 Then
		Lev$ = Lvl(GX, GY)
		If Lev = "O" Or Lev = "X" Or Lev = "M" Or Lev = "R" Then
			If Powers(ID, 4) > 0 And Lev <> "O" Then
				If Lev = "X" Then
					Explosion(GX, GY, 1, ID, 4)
					KillGreenMine(GX, GY, ID, 4)
					Speed#(ID) = Speed#(ID) * 0.3
				ElseIf Lev = "M" Then
					Explosion(GX, GY, 2, ID, 4)
					KillBlueMine(GX, GY, ID, 4)
					Speed#(ID) = Speed#(ID) * 0.2
				ElseIf Lev = "R" Then
					Explosion(GX, GY, 3, ID, 4)
					KillRedMine(GX, GY, ID, 4)
					Speed#(ID) = Speed#(ID) * 0.1
				End If
			Else
				PositionEntity objTank, LastX#(ID), 0, LastZ#(ID)
			End If
		End If
	Else
		PositionEntity objTank, LastX#(ID), 0, LastZ#(ID)
		Speed#(ID) = 0
	End If
End Function

Function HandleBullets()
	NoBul(1) = True
	NoBul(2) = True
	For Bullets.Bullet = Each Bullet
		BE = False
		MoveEntity Bullets\mdl, 0, 0, -1 * BULLETSPEED#
		NoBul(Bullets\Shooter) = False
		GX = GridX(EntityX(Bullets\mdl, True))
		GY = GridY(EntityZ(Bullets\mdl, True))
		If GX <= LX And GX >= 1 And GY <= LY And GY >= 1 Then
			Lev$ = Lvl(GX, GY)
			If Lev = "O" Then
				Explosion(GX, GY, Bullets\Rad, Bullets\Shooter, Bullets\St)
				BE = True
			ElseIf Lev = "X" Then
				KillGreenMine(GX, GY, Bullets\Shooter, Bullets\St)
				Explosion(GX, GY, Bullets\Rad, Bullets\Shooter, Bullets\St)
				BE = True
			ElseIf Lev = "M" Then
				If KillBlueMine(GX, GY, Bullets\Shooter, Bullets\St) Then
					If Bullets\Rad > 2 Then
						Explosion(GX, GY, Bullets\Rad, Bullets\Shooter, STBLUEMINE)
					Else				
						Explosion(GX, GY, 2, Bullets\Shooter, STBLUEMINE)
					End If
				Else
					Explosion(GX, GY, Bullets\Rad, Bullets\Shooter, Bullets\St)
				End If
				BE = True
			ElseIf Lev = "R" Then
				If KillRedMine(GX, GY, Bullets\Shooter, Bullets\St) Then
					If Bullets\Rad > 3 Then
						Explosion(GX, GY, Bullets\Rad, Bullets\Shooter, STREDMINE)
					Else				
						Explosion(GX, GY, 3, Bullets\Shooter, STREDMINE)
					End If
				Else
					Explosion(GX, GY, Bullets\Rad, Bullets\Shooter, Bullets\St)
				End If
				BE = True
			ElseIf Bullets\Shooter = 2 Then
				If GridX(EntityX(objBlackTank, True)) = GX And GridY(EntityZ(objBlackTank, True)) = GY Then
					HitBlackTank(Bullets\Shooter)
					Scores(2) = Scores(2) + ENEMY
					Repo(2) = True
					Explosion(GX, GY, Bullets\Rad, Bullets\Shooter, Bullets\St)
					BE = True
				End If
			ElseIf objWhiteTank > 0 And Bullets\Shooter = 1 Then
				If GridX(EntityX(objWhiteTank, True)) = GX And GridY(EntityZ(objWhiteTank, True)) = GY Then
					HitWhiteTank(Bullets\Shooter)
					Scores(1) = Scores(1) + ENEMY
					Repo(1) = True
					Explosion(GX, GY, Bullets\Rad, Bullets\Shooter, Bullets\St)
					BE = True
				End If
			End If
			If BE Then
				FreeEntity Bullets\mdlShadow
				FreeEntity Bullets\mdl
				Delete Bullets.Bullet
			End If			
		Else
			Explosion(GX, GY, 1, Bullets\Shooter, Bullets\St)
			FreeEntity Bullets\mdlShadow
			FreeEntity Bullets\mdl
			Delete Bullets.Bullet
		End If
	Next
End Function

Function Explosion(GX, GY, Radius, Shooter, St)
	If Sound And Radius > 1 And Mode = 1 Then PlaySound sndExplosion
	Explosions.Explosion = New Explosion
	Explosions\x = GX
	Explosions\y = GY
	Explosions\radius = Radius
	Explosions\shooter = Shooter
	Explosions\St = St
	Explosions\scale# = 0
	For Count = 1 To 3
		Explosions\mdl[count] = LoadMesh("models\explosion.b3d")
		RotateEntity Explosions\mdl[count], 90, 0, 0
		EntityTexture Explosions\mdl[count], texExplosions(count)
		PositionEntity Explosions\mdl[count], X3D(GX), 0, Z3D(GY)
		EntityAlpha Explosions\mdl[count], 0.6 + Float(Count - 4) * 0.1
		ScaleEntity Explosions\mdl[count], 0, 0, 0
	Next
	If Sound And Mode = 2 Then EmitSound(sndExplosions(Radius), Explosions\mdl[1])
End Function

Function HandleExplosions()
	NoExp(1) = True
	NoExp(2) = True
	For Explosions.Explosion = Each Explosion
		NoExp(Explosions\Shooter) = False
		If Not Explosions\Fading Then
			sc# = Explosions\scale# + EXPLOSIONSPEED#
			Explosions\scale# = sc#
			ScaleEntity Explosions\mdl[1], sc# * 0.33 * 0.2, sc# * 0.33 * 0.2, sc# * 0.33 * 0.2
			ScaleEntity Explosions\mdl[2], sc# * 0.60 * 0.2, sc# * 0.60 * 0.2, sc# * 0.60 * 0.2
			ScaleEntity Explosions\mdl[3], sc# * 1.00 * 0.2, sc# * 1.00 * 0.2, sc# * 1.00 * 0.2
			If sc# > Explosions\Radius * 2.5 Then
				Explosions\Fading = True
				If Explosions\radius > 1 Then
					For GX = Explosions\X - (Explosions\radius - 1) To Explosions\X + (Explosions\radius - 1)
						For GY = Explosions\Y - (Explosions\radius - 1) To Explosions\Y + (Explosions\radius - 1)
							If GX <= LX And GX >= 1 And GY <= LY And GY >= 1 Then
								Lev$ = Lvl(GX, GY)
								If Lev = "O" Then
									Explosion(GX, GY, 1, Explosions\Shooter, Explosions\St)
								End If
								If Lev = "X" Then
									If KillGreenMine(GX, GY, Explosions\Shooter, Explosions\St) Then
										Explosion(GX, GY, 1, Explosions\Shooter, 2)
									End If
								End If
								If Lev = "M" Then
									If KillBlueMine(GX, GY, Explosions\Shooter, Explosions\St) Then
										Explosion(GX, GY, 2, Explosions\Shooter, 4)
									End If
								End If
								If Lev = "R" Then
									If KillRedMine(GX, GY, Explosions\Shooter, Explosions\St) Then
										Explosion(GX, GY, 3, Explosions\Shooter, 8)
									End If
								End If
								If GridX(EntityX(objBlackTank, True)) = GX And GridY(EntityZ(objBlackTank, True)) = GY Then
									Explosion(GX, GY, 1, Explosions\Shooter, Explosions\St)
									HitBlackTank(Explosions\Shooter)
								End If
								If objWhiteTank > 0 Then
									If GridX(EntityX(objWhiteTank, True)) = GX And GridY(EntityZ(objWhiteTank, True)) = GY Then
										Explosion(GX, GY, 1, Explosions\Shooter, Explosions\St)
										HitWhiteTank(Explosions\Shooter)
									End If
								End If
							Else
								
							End If
						Next
					Next
				End If
			End If
		Else
			sc# = Explosions\scale# - EXPLOSIONSPEED# * 2
			Explosions\scale# = sc#
			ScaleEntity Explosions\mdl[1], sc# * 0.33 * 0.2, sc# * 0.33 * 0.2, sc# * 0.33 * 0.2
			ScaleEntity Explosions\mdl[2], sc# * 0.60 * 0.2, sc# * 0.60 * 0.2, sc# * 0.60 * 0.2
			ScaleEntity Explosions\mdl[3], sc# * 1.00 * 0.2, sc# * 1.00 * 0.2, sc# * 1.00 * 0.2
			If Explosions\scale# < 0 Then
				FreeEntity Explosions\mdl[1]
				FreeEntity Explosions\mdl[2]
				FreeEntity Explosions\mdl[3]
				Delete Explosions.Explosion
			End If
		End If
	Next	
End Function

Function KillGreenMine(GX, GY, Shooter, St)
	For GM.GreenMine = Each GreenMine
		If GM\X = GX And GM\Y = GY Then
			If Mode = 2 Then
				GM\HP = GM\HP - St
			Else
				GM\HP = 0
			End If
			If GM\HP <= 0 Then
				If Mode = 2 Then
					SpawnPowerUp(GX, GY, 2)
				End If
				GreenMines = GreenMines - 1
				Scores(Shooter) = Scores(Shooter) + GREENMINE
				Lvl(GX, GY) = " "
				FreeEntity GM\mdl
				Delete GM.GreenMine
				Return True
			End If
		End If
	Next
	Return False
End Function

Function KillBlueMine(GX, GY, Shooter, St)
	For BM.BlueMine = Each BlueMine
		If BM\X = GX And BM\Y = GY Then
			If Mode = 2 Then
				BM\HP = BM\HP - St
			Else
				BM\HP = 0
			End If
			If BM\HP <= 0 Then
				If Mode = 2 Then
					SpawnPowerUp(GX, GY, 5)
				End If
				BlueMines = BlueMines - 1
				Scores(Shooter) = Scores(Shooter) + BLUEMINE
				Lvl(GX, GY) = " "
				FreeEntity BM\mdl
				Delete BM.BlueMine
				Return True
			End If
		End If
	Next
	Return False
End Function

Function KillRedMine(GX, GY, Shooter, St)
	For RM.RedMine = Each RedMine
		If RM\X = GX And RM\Y = GY Then
			If Mode = 2 Then
				RM\HP = RM\HP - St
			Else
				RM\HP = 0
			End If
			If RM\HP <= 0 Then
				If Mode = 2 Then
					SpawnPowerUp(GX, GY, 25)
				End If
				RedMines = RedMines - 1
				Scores(Shooter) = Scores(Shooter) + REDMINE
				Lvl(GX, GY) = " "
				FreeEntity RM\mdl
				Delete RM.RedMine
				Return True
			End If
		End If
	Next
	Return False
End Function

Function HitBlackTank(Shooter)
	If Shooter = 1 Then
		If Players = 1 Then
			If Not Spin(1) Then
				Scores(1) = Scores(1) + OWNEXP1
			End If
			If Scores(1) < 0 Then
				Scores(1) = 0
			End If
		Else
			If Not Spin(1) Then
				Scores(2) = Scores(2) + OWNEXP2
			End If
		End If
		Spin(1) = True
		Repo(1) = True
	Else
		Spin(1) = True
		Repo(1) = True
	End If
	If Spin(1) And Powers(1, 3) > 0 Then
		Spin(1) = False
		Repo(1) = False
	End If
End Function

Function HitWhiteTank(Shooter)
	If Shooter = 2 Then
		If Not Spin(2)
			Scores(1) = Scores(1) + OWNEXP2
		End If
		Spin(2) = True
		Repo(2) = True
	Else
		Spin(2) = True
		Repo(2) = True
	End If
	If Spin(2) And Powers(2, 3) > 0 Then
		Spin(2) = False
		Repo(2) = False
	End If
End Function

Function Render(imgTimer, imgScoreB, imgScoreW, imgGUI, ScreenRatio#)
	UpdateWorld
	RenderWorld
	
	DrawImage imgTimer, 100 * ScreenRatio# + 2.5 * ScreenRatio#, 25 * ScreenRatio#, Left(Time$, 1)
	DrawImage imgTimer, 100 * ScreenRatio# + 37.5 * ScreenRatio#, 25 * ScreenRatio#, Right(Time$, 1)
	
	DrawScore(Scores(1), imgScoreB, 65, ScreenRatio#)
	DrawScore(Scores(2), imgScoreW, 820, ScreenRatio#)

	DrawImage imgGUI, 0, 0
	
	Color 128, 128, 128
	FPSCount = FPSCount + 1
	If FPSTimer < MilliSecs() - 1000
		FPS = FPSCount
		FPSCount = 0
		FPSTimer = MilliSecs()
	End If
	If Debug Then
		OutlineText(900 * ScreenRatio#, 728 * ScreenRatio#, "FPS : " + FPS, False, False)
		OutlineText(900 * ScreenRatio#, 743 * ScreenRatio#, "Tris: " + TrisRendered(), False, False)
	End If
	
End Function

Function Within(value#, min#, max#)
	If value# >= min# And value# <= max# Then
		Return True
	Else
		Return False
	End If
End Function

Function Range(value#, test#, mindiff#, maxdiff#)
	If value# >= test# - mindiff# And value# <= test# + maxdiff# Then
		Return True
	Else
		Return False
	End If
End Function

Function CenterImage(img, x, y, w, h)
	iw = ImageWidth(img)
	ih = ImageHeight(img)
	ix = x + (w - x) / 2 - iw / 2
	iy = y + (h - y) / 2 - ih / 2
	DrawImage img, ix, iy
End Function

Function SpawnPowerUp(x, y, chance)
	If Rand(1, 100) <= chance Then
		PowerUps.PowerUp = New PowerUp
		PowerUps\mdl = CreateCube()
		PositionEntity PowerUps\mdl, X3D(X), 0, Z3D(Y)
		ScaleEntity PowerUps\mdl, 1.5, 1.5, 1.5
		EntityTexture PowerUps\mdl, texPowerUp
		PowerUps\mdlshadow = CreateCube(PowerUps\mdl)
		EntityColor PowerUps\mdlShadow, 0, 0, 0
		EntityAlpha PowerUps\mdlShadow, 0.6
		ScaleEntity PowerUps\mdlShadow, 1, 0.1, 1
		MoveEntity PowerUps\mdlShadow, 0, -2, 0
		PowerUps\x = x
		PowerUps\y = y
		PowerUps\Typ = Rand(1, 15) 		
	End If
End Function

Function HandlePowerUps()
	For PowerUps.PowerUp = Each PowerUp
		TurnEntity PowerUps\mdl, 0, -3, 0
	Next
End Function

; ADD A NEW MESSAGE, MOVING ALL OTHERS ONE UP
Function AddMessages()
	For Count = (NumMsgs - 1) To 0 Step -1
		Messages(Count + 1) = Messages(Count)
		MsgR(Count + 1) = MsgR(Count)
		MsgG(Count + 1) = MsgG(Count)
		MsgB(Count + 1) = MsgB(Count)
	Next
	LongMsg = False
	If StringWidth(NewMessage$) > 512.0 * screenratio#  Then 
		SpacePos = Len(NewMessage$)
		While (StringWidth(Mid(NewMessage$, 1, SpacePos)) > 512.0 * screenratio#) Or Mid(NewMessage$, SpacePos, 1) <> " "
			SpacePos = SpacePos - 1
		Wend
		SecondMessage$ = Mid(NewMessage$, SpacePos + 1)
		NewMessage$ = Mid(NewMessage$, 1, SpacePos)
		LongMsg = True
	End If
	Messages(0) = NewMessage$
	MsgR(0) = NewR
	MsgG(0) = NewG
	MsgB(0) = NewB
	NewMessage$ = ""
	If LongMsg Then
		NewMessage$ = SecondMessage
		AddMessages()
	End If
	Return
End Function